=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-12-28 19:47:54 +0000
+++ bzrlib/__init__.py	2006-01-03 15:10:11 +0000
@@ -95,7 +95,10 @@
 
 
 def get_bzr_revision():
-    """If bzr is run from a branch, return (revno,revid) or None"""
+    """If bzr is run from a branch, return (revno,revid) or None
+
+    deprecated in bzr 0.7
+    """
     import bzrlib.errors
     from bzrlib.branch import Branch
     
@@ -103,7 +106,7 @@
         branch = Branch.open(os.path.dirname(__path__[0]))
         rh = branch.revision_history()
         if rh:
-            return len(rh), rh[-1], branch
+            return len(rh), rh[-1]
         else:
             return None
     except bzrlib.errors.BzrError:

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-12-28 19:47:54 +0000
+++ bzrlib/builtins.py	2006-01-03 15:10:11 +0000
@@ -1461,15 +1461,31 @@
             bzrlib.ui.ui_factory = save_ui
 
 
+def _get_bzr_branch():
+    """If bzr is run from a branch, return Branch or None"""
+    import bzrlib.errors
+    from bzrlib.branch import Branch
+    from bzrlib.osutils import abspath
+    from os.path import dirname
+    
+    try:
+        branch = Branch.open(dirname(abspath(dirname(__file__))))
+        return branch
+    except bzrlib.errors.BzrError:
+        return None
+    
+
 def show_version():
     print "bzr (bazaar-ng) %s" % bzrlib.__version__
     # is bzrlib itself in a branch?
-    bzrrev = bzrlib.get_bzr_revision()
-    if bzrrev:
-        revno, revision_id, branch = bzrrev
+    branch = _get_bzr_branch()
+    if branch:
+        rh = branch.revision_history()
+        revno = len(rh)
         print "  bzr checkout, revision %d" % (revno,)
         print "  nick: %s" % (branch.nick,)
-        print "  revid: %s" % (revision_id,)
+        if rh:
+            print "  revid: %s" % (rh[-1],)
     print bzrlib.__copyright__
     print "http://bazaar-ng.org/"
     print

